include doszip.inc
include string.inc
include time.inc
include io.inc
ifdef __ZIP__
 include unzip.inc
endif
ifdef __DLL__
 include dll.inc
endif

externdef	scan_fblock:S_WFBLK

ID_RDONLY	equ 1*16
ID_HIDDEN	equ 2*16
ID_SYSTEM	equ 3*16
ID_ARCHIVE	equ 4*16
ID_CREATEDATE	equ 5*16
ID_CREATETIME	equ 6*16
ID_MODDATE	equ 7*16
ID_MODTIME	equ 8*16
ID_ACCESSDATE	equ 9*16
ID_ACCESSTIME	equ 10*16
ID_SET		equ 11*16
ID_CANCEL	equ 12*16

ifdef __ZIP__
.data
format_zx label byte
	db '%08X',10
	db '%04X',10
	db '%04X',10
	db '%04X',10
	db '%04X',10
	db '%04X',10
	db '%08X',10
	db '%08X',10
	db '%08X',10
	db '%04X',10
	db '%04X',10,10,10
	db '%04X', 10
	db '%08X',10
	db '%08X',10
	db '%08X',10
	db 0
format_zu label byte
	db '%16u',10
	db '%16u',10
	db '%16u',10
	db '%16u',10
	db 0
endif ; __ZIP__

.code

cmfileattrib proc private uses esi edi ebx
local fblk:dword
local flag:size_t
local fname:dword
local dialog:dword
local ft:S_FTIME
	mov fname,eax
	mov fblk,edx
	mov flag,ecx
	.if rsopen(IDD_DZFileAttributes)
	    mov dialog,eax
	    mov ebx,dialog
	    mov al,_O_FLAGB
	    mov edx,flag
	    .if dl & _A_RDONLY
		or [ebx+ID_RDONLY],al
	    .endif
	    .if dl & _A_HIDDEN
		or [ebx+ID_HIDDEN],al
	    .endif
	    .if dl & _A_SYSTEM
		or [ebx+ID_SYSTEM],al
	    .endif
	    .if dl & _A_ARCH
		or [ebx+ID_ARCHIVE],al
	    .endif
	    .if wfindfirst(fname,addr scan_fblock,00FFh) != -1
		invoke wcloseff,eax
		invoke strftime,[ebx].S_TOBJ.to_data[ID_ACCESSTIME],
		    addr scan_fblock.wf_timeaccess
		invoke strfdate,[ebx].S_TOBJ.to_data[ID_ACCESSDATE],
		    addr scan_fblock.wf_timeaccess
		invoke strftime,[ebx].S_TOBJ.to_data[ID_CREATETIME],
		    addr scan_fblock.wf_timecreate
		invoke strfdate,[ebx].S_TOBJ.to_data[ID_CREATEDATE],
		    addr scan_fblock.wf_timecreate
		invoke strftime,[ebx].S_TOBJ.to_data[ID_MODTIME],
		    addr scan_fblock.wf_time
		invoke strfdate,[ebx].S_TOBJ.to_data[ID_MODDATE],
		    addr scan_fblock.wf_time
		invoke dlinit,dialog
		invoke dlshow,dialog
		mov eax,[ebx+4]
		add eax,0213h
		mov dl,ah
		invoke scpath,eax,edx,21,fname
		.if dlevent(dialog)
		    mov al,_O_FLAGB
		    sub edx,edx
		    .if [ebx+ID_RDONLY] & al
			or dl,_A_RDONLY
		    .endif
		    .if [ebx+ID_SYSTEM] & al
			or dl,_A_SYSTEM
		    .endif
		    .if [ebx+ID_ARCHIVE] & al
			or dl,_A_ARCH
		    .endif
		    .if [ebx+ID_HIDDEN] & al
			or dl,_A_HIDDEN
		    .endif
		    mov al,byte ptr flag
		    and al,_A_ARCH or _A_SYSTEM or _A_HIDDEN or _A_RDONLY
		    .if al != dl
			.if byte ptr flag & _A_SUBDIR
			     mov flag,edx
			     invoke setfattr,fname,0
			     mov edx,flag
			.endif
			invoke setfattr,fname,edx
		    .endif
		    .if osopen(fname,_A_NORMAL,M_WRONLY,A_OPEN) != -1
			mov esi,eax
			GetTime macro t
			invoke atodate,[ebx].S_TOBJ.to_data[ID_&t&DATE]
			mov    edx,eax
			invoke atotime,[ebx].S_TOBJ.to_data[ID_&t&TIME]
			or     eax,edx
			endm
			GetTime MOD
			invoke setftime,esi,eax
			GetTime CREATE
			invoke setftime_create,esi,eax
			GetTime ACCESS
			invoke setftime_access,esi,eax
			invoke close,esi
		    .endif
		.endif
	    .endif
	    invoke dlclose,dialog
	.endif
	ret
cmfileattrib endp

ifdef __ZIP__
cmzipattrib proc private uses esi edi ebx ebp
	mov edi,edx	; CX attrib
	mov ebx,cpanel
	.if !(cl & _A_SUBDIR)
	    mov ebp,ecx
	    .if wsopenarch([ebx].S_PANEL.pn_wsub) != -1
		push ebp
		mov ebp,eax
		;------------------------------------------------------------
		; CRC, compressed size and local offset stored at end of FBLK
		;------------------------------------------------------------
		invoke strlen,addr [edi].S_FBLK.fb_name
		add eax,SIZE S_FBLK
		add edi,eax
		mov eax,[edi+4]
		mov zip_central.cz_crc,eax
		mov eax,[edi+8]
		mov zip_central.cz_csize,eax
		mov eax,[edi]
		mov zip_central.cz_off_local,eax
		invoke lseek,ebp,eax,SEEK_SET	; seek to and read local offset
		invoke osread,ebp,addr zip_local,SIZE S_LZIP
		pop edi ; FBLK.flag
		.if eax == SIZE S_LZIP && word ptr zip_local.lz_zipid == ZIPLOCALID \
			&& word ptr zip_local.lz_pkzip == ZIPHEADERID
		    invoke osread,ebp,addr entryname,zip_local.lz_fnsize
		    mov esi,eax
		    invoke close,ebp
		    .if si == zip_local.lz_fnsize
			mov entryname[esi],0
			.if rsopen(IDD_DZZipAttributes)
			    mov ebp,eax
			    mov ebx,[eax+4]
			    invoke dlshow,eax
			    add ebx,0104h
			    mov dl,bh
			    invoke scpath,ebx,edx,54,addr entryname
			    and edi,_A_FATTRIB
			    add dl,03h
			    add bl,17h
			    mov ecx,88
			    invoke scputf,ebx,edx,0,ecx,addr format_zx,
				dword ptr zip_local,
				zip_local.lz_version,	; version needed to extract
				zip_local.lz_flag,	; general purpose bit flag
				zip_local.lz_method,	; compression method
				zip_local.lz_time,	; last mod file time
				zip_local.lz_date,	; last mod file date
				zip_local.lz_crc,	; crc-32
				zip_local.lz_csize,	; compressed size
				zip_local.lz_fsize,	; uncompressed size
				zip_local.lz_fnsize,	; file name length
				zip_local.lz_extsize,	; extra field length
				edi,
				zip_central.cz_off_local,
				zip_central.cz_csize,
				zip_central.cz_crc
			    add dl,07h
			    add bl,08h
			    invoke scputf,ebx,edx,0,ecx,addr format_zu,
				zip_local.lz_csize,	; compressed size
				zip_local.lz_fsize,	; uncompressed size
				zip_local.lz_fnsize,	; file name length
				zip_local.lz_extsize	; extra field length
			    add dl,06h
			    add bl,12h
			    .if edi & _A_RDONLY
				invoke scputc,ebx,edx,1,'x'
			    .endif
			    inc dl
			    .if edi & _A_HIDDEN
				invoke scputc,ebx,edx,1,'x'
			    .endif
			    inc dl
			    .if edi & _A_SYSTEM
				invoke scputc,ebx,edx,1,'x'
			    .endif
			    inc dl
			    .if edi & _A_ARCH
				invoke scputc,ebx,edx,1,'x'
			    .endif
			    invoke dlevent,ebp
			    invoke dlclose,ebp
			.endif
		    .else
			xor eax,eax
		    .endif
		.else
		    invoke close,ebp
		.endif
	    .endif
	.endif
	ret
cmzipattrib endp
endif

cmattrib proc
	mov eax,cpanel
	.if panel_curobj()
    ifdef __ROT__
	    .if !(ecx & _FB_ROOTDIR)
    endif
    ifdef __ARC__
		.if ecx & _FB_ARCHIVE
	ifdef __DLL__
		    .if ecx & _FB_ARCHEXT

			mov ebx,cpanel
			mov ebx,[ebx].S_PANEL.pn_wsub
			invoke dll_call,_DLL_ATTRIB,ebx,edx,0,0
		    .else
	endif
	ifdef __ZIP__
			invoke cmzipattrib
	endif
	ifdef __DLL__
		    .endif
	endif

		.else
		    invoke cmfileattrib
		.endif
    else
		invoke cmfileattrib
    endif ; __ARC__
    ifdef __ROT__
	    .endif
    endif
	.endif
	ret
cmattrib endp

	END

