include doszip.inc
include string.inc
include io.inc

.data

cp_name db 'Name',0
cp_date db 'Date',0
cp_time db 'Time',0
cp_size db 'Size',0

S_PRECT STRUC
p_name  dd ?
p_type  dd ?	; 0+Name,1+Size,2+Date,3+Time
p_putfile dd ?
p_rect  S_RECT <>
S_PRECT ENDS

PRECT	label S_PRECT
	S_PRECT < 0,0,fbputsl,<1,2,12,1>>  ; Vertical Short List
	S_PRECT <26,3,fbputsd,<1,2,38,1>>  ; Vertical Short Detail
	S_PRECT < 0,0,fbputsl,<1,2,12,1>>  ; Horizontal Short List
	S_PRECT <26,3,fbputld,<1,2,78,1>>  ; Horizontal Short Detail
	S_PRECT < 0,0,fbputll,<1,2,18,1>>  ; Vertical Long List
	S_PRECT <16,2,fbputld,<1,2,38,1>>  ; Vertical Long Detail
	S_PRECT < 0,0,fbputll,<1,2,18,1>>  ; Horizontal Long List
	S_PRECT <26,3,fbputld,<1,2,78,1>>  ; Horizontal Long Detail
	S_PRECT < 0,0,fbputll,<1,2,38,1>>  ; Vertical Wide
	S_PRECT < 0,0,fbputll,<1,2,78,1>>  ; Horizontal Wide

.code

prect_open proc uses esi edi ebx ; AX = panel
local panel:dword
local rect:S_RECT
local xcell:dword
local xlrc:S_RECT
local prect:S_RECT
local dlwp:dword
	mov	esi,eax
	mov	panel,eax
	invoke  comhide
	mov	edi,[esi].S_PANEL.pn_path
	mov	edi,[edi].S_PATH.wp_flag
	xor	edx,edx		; x,y
	mov	eax,_scrcol	; cols
	shr	eax,1
	mov	ah,bye ptr _scrrow; rows
	mov	ecx,cflag
	mov	bh,9		; panel size (rows)
	.if !(ecx & _C_COMMANDLINE)
	    inc ah		; rows++
	.endif
	.if ecx & _C_MENUSLINE
	    inc dh		; y++
	    dec ah		; rows--
	.endif
	.if ecx & _C_STATUSLINE
	    dec ah		; rows--
	.endif
	.if ecx & _C_HORIZONTAL && !(ecx & _C_WIDEVIEW)
	    shr ah,1		; rows / 2
	    dec bh
	.endif
	mov bl,ah
	sub bl,bh		; rows - bh (size)
	.if bl < byte ptr config.c_panelsize
	    mov byte ptr config.c_panelsize,bl
	.endif
	sub ah,byte ptr config.c_panelsize
	.if ecx & _C_HORIZONTAL
	    mov al,byte ptr _scrcol	; cols = 80
	    .if edi & _W_PANELID && !(ecx & _C_WIDEVIEW)
		add dh,ah		; y += rows
	    .endif
	.elseif edi & _W_PANELID && !(ecx & _C_WIDEVIEW)
	    mov dl,byte ptr _scrcol	; x = 40
	    shr dl,1
	.endif
	mov word ptr rect,dx
	mov word ptr rect+2,ax

	xor ebx,ebx
	.if ecx & _C_HORIZONTAL
	    mov bl,2
	.endif
	.if edi & _W_DETAIL
	    inc bl
	.endif
	.if edi & _W_LONGNAME
	    add bl,4
	.endif
	.if edi & _W_WIDEVIEW
	    mov bl,8
	    .if ecx & _C_HORIZONTAL
		inc bl
	    .endif
	.endif
	shl	ebx,4
	add	ebx,offset PRECT
	mov	xcell,ebx
	mov	dl,[ebx].S_PRECT.p_rect.rc_col
	push	eax
	mov	eax,[ebx].S_PRECT.p_rect
	mov	prect,eax
	mov	eax,_scrcol
	.if !dl == 78
	    shr eax,1
	    .if !dl == 38
		.if dl == 18
		    shr eax,1
		.else
		    mov eax,14
		.endif
	    .endif
	.endif
	sub	eax,2
	pop	ecx
	mov	prect.rc_col,al
	mov	eax,prect
	add	ax,word ptr rect
	mov	xlrc,eax
	mov	ebx,[esi].S_PANEL.pn_xl
	mov	[ebx].S_XCEL.xl_cpos,eax
	sub	ch,3
	mov	[ebx].S_XCEL.xl_rows,ch
	movzx	eax,cl
	dec	al
	mov	cl,xlrc.rc_col
	inc	cl
	div	cl
	mov [ebx].S_XCEL.xl_cols,al
	mov ebx,[esi].S_PANEL.pn_dialog
	.if [ebx].S_DOBJ.dl_flag & _D_DOPEN
	    invoke dlclose,[esi].S_PANEL.pn_xl
	    invoke dlclose,ebx
	.endif

	mov eax,rect
	mov [ebx].S_DOBJ.dl_rect,eax
	mov al,at_background[B_Panel]
	or  al,at_foreground[F_Frame]
	.if dlopen(ebx,eax,0)
	    xor eax,eax
	    mov word ptr rect,ax
	    mov edx,[esi].S_PANEL.pn_dialog
	    mov edx,[edx].S_DOBJ.dl_wp
	    mov dlwp,edx
	    movzx ecx,rect.rc_col
	    add edx,ecx
	    add edx,ecx
	    mov ah,at_background[B_Panel]
	    or  ah,at_foreground[F_Panel]
	    mov al,' '
	    invoke wcputw,edx,ecx,eax
	    .if edi & _W_MINISTATUS
		mov al,2
		sub rect.rc_row,al
		mov edx,[esi].S_PANEL.pn_xl
		sub [edx].S_XCEL.xl_rows,al
		.if edi & _W_DRVINFO
		    sub rect.rc_row,al
		    sub [edx].S_XCEL.xl_rows,al
		    .if !(cflag & _C_HORIZONTAL)
			dec rect.rc_row
			dec [edx].S_XCEL.xl_rows
		    .endif
		.endif
		sub eax,eax
		mov ah,at_background[B_Panel]
		or  ah,at_foreground[F_Frame]
		movzx edx,rect.rc_col
		invoke rcframe,rect,dlwp,edx,eax
	    .endif
	    mov ebx,xcell
	    mov eax,[ebx].S_PRECT.p_putfile
	    mov [esi].S_PANEL.pn_putfcb,eax

	    mov eax,rect
	    mov xlrc,eax
	    mov al,prect.rc_col
	    add al,2
	    mov xlrc.rc_col,al
	    mov dl,12
	    mov dh,at_background[B_Panel]
	    or  dh,at_foreground[F_Frame]
	    movzx ecx,rect.rc_col
	    push edi
	    mov edi,ecx
	    add edi,edi
	    add edi,dlwp
	    movzx eax,prect.rc_col
	    mov esi,eax
	    inc esi
	    add esi,esi
	    and al,-2
	    sub al,2
	    .if [ebx].S_PRECT.p_type == 0
		add edi,eax
		.repeat
		    invoke wcputs,edi,ecx,ecx,addr cp_name
		    add edi,esi
		    invoke rcframe,xlrc,dlwp,ecx,edx
		    movzx eax,prect.rc_col
		    inc	  eax
		    movzx ebx,xlrc.rc_x
		    add	  ebx,eax
		    .break .if bh
		    add xlrc.rc_x,al
		    add eax,ebx
		    .break .if ah
		    movzx ebx,xlrc.rc_col
		    add eax,ebx
		    .break .if ah
		.until al > rect.rc_col
		mov al,prect.rc_col
		add al,2
		.if al != rect.rc_col
		    invoke wcputs,edi,ecx,ecx,addr cp_name
		.endif
	    .elseif [ebx].S_PRECT.p_type == 2
		sub eax,[ebx].S_PRECT.p_name
		add eax,edi
		invoke wcputs,eax,ecx,ecx,addr cp_name
		lea eax,[edi+ecx*2-14]
		invoke wcputs,eax,ecx,ecx,addr cp_date
		lea eax,[edi+ecx*2-34]
		invoke wcputs,eax,ecx,ecx,addr cp_size
		sub xlrc.rc_col,9
		invoke rcframe,xlrc,dlwp,ecx,edx
		sub xlrc.rc_col,11
		invoke rcframe,xlrc,dlwp,ecx,edx
	    .elseif [ebx].S_PRECT.p_type == 3
		sub eax,[ebx].S_PRECT.p_name
		add eax,edi
		invoke wcputs,eax,ecx,ecx,addr cp_name
		lea eax,[edi+ecx*2-10]
		invoke wcputs,eax,ecx,ecx,addr cp_time
		lea eax,[edi+ecx*2-26]
		invoke wcputs,eax,ecx,ecx,addr cp_date
		lea eax,[edi+ecx*2-46]
		invoke wcputs,eax,ecx,ecx,addr cp_size
		sub xlrc.rc_col,6
		invoke rcframe,xlrc,dlwp,ecx,edx
		sub xlrc.rc_col,9
		invoke rcframe,xlrc,dlwp,ecx,edx
		sub xlrc.rc_col,11
		invoke rcframe,xlrc,dlwp,ecx,edx
	    .endif
	    pop edi
	    mov ebx,dlwp
	    sub eax,eax
	    mov edx,eax
	    mov al,rect.rc_col
	    add al,2
	    lea eax,[ebx+eax*2]
	    mov byte ptr [eax],':'
	    mov byte ptr [eax+2],25
	    mov eax,panel
	    mov ecx,[eax].S_PANEL.pn_dialog
	    mov dl,[ecx].S_DOBJ.dl_rect.rc_col
	    mov ecx,[ecx].S_DOBJ.dl_rect
	    xor cx,cx
	    mov eax,6
	    mov ah,at_background[B_Panel]
	    or  ah,at_foreground[F_Frame]
	    invoke rcframe,ecx,ebx,edx,eax
	    sub eax,eax
	    mov al,rect.rc_row
	    mov ah,rect.rc_col
	    .if edi & _W_MINISTATUS
		dec al
		mul ah
		.if edi & _W_DRVINFO
		    mov byte ptr [ebx+eax*2+4],1Fh
		.else
		    mov byte ptr [ebx+eax*2+4],07h
		    movzx edx,rect.rc_col
		    add eax,edx
		    mov byte ptr [ebx+eax*2-6],1Fh
		.endif
	    .else
		mul ah
		mov byte ptr [ebx+eax*2-6],1Eh
	    .endif
	    mov esi,panel
	    mov eax,cflag
	    and eax,_C_WIDEVIEW
	    .if !eax || (eax && esi == cpanel)
		invoke dlshow,[esi].S_PANEL.pn_dialog
		or edi,_W_VISIBLE
		and edi,not _W_WHIDDEN
	    .else
		or edi,_W_WHIDDEN
	    .endif
	    mov edx,[esi].S_PANEL.pn_path
	    mov [edx].S_PATH.wp_flag,edi
	.endif
	push	eax
	invoke  comshow
	pop	eax
	ret
prect_open endp

prect_close proc uses esi
	mov esi,eax
	mov eax,[eax].S_PANEL.pn_path
	mov eax,[eax].S_PATH.wp_flag
	and eax,_W_VISIBLE
	.if !ZERO?
	    mov eax,esi
	    invoke prect_hide
	    invoke dlclose,[esi].S_PANEL.pn_dialog
	    mov eax,1
	.endif
	ret
prect_close endp

prect_hide proc uses esi
	mov esi,eax
	mov edx,[eax].S_PANEL.pn_path
	mov eax,[edx].S_PATH.wp_flag
	.if eax & _W_WHIDDEN
	    xor eax,_W_WHIDDEN
	    mov [edx].S_PATH.wp_flag,eax
	    mov eax,1
	.elseif eax & _W_VISIBLE
	    xor eax,_W_VISIBLE
	    mov [edx].S_PATH.wp_flag,eax
	    invoke dlclose,[esi].S_PANEL.pn_xl
	    invoke dlhide,[esi].S_PANEL.pn_dialog
	    mov eax,1
	.else
	    sub eax,eax
	.endif
	ret
prect_hide endp

prect_open_ab proc
	mov al,byte ptr cflag
	and al,_C_PANELID
	mov eax,offset spanela
	.if !ZERO?
	    mov eax,offset spanelb
	.endif
	mov cpanel,eax
	xor eax,eax
	.if flaga & _W_VISIBLE
	    mov eax,offset spanela
	    invoke prect_open
	.endif
	.if flagb & _W_VISIBLE
	    mov eax,offset spanelb
	    invoke prect_open
	.endif
	ret
prect_open_ab endp

	END
